#include <allegro.h>
#include <math.h>

void Inicia_Allegro();
void Move_Retangulo();
void Desenha_Retangulo();
void Inicia_Programa();
void Teste_Colisao(int Xa, int Ya);
void Inicia_Dados(int Xa, int Ya, int Xb, int Yb);

BITMAP *Retangulos;

struct
{
	int X[4];
	int Y[4];
}Quadrado[2];

int main(void)
{
	Inicia_Programa();

	return 0;
}
END_OF_MAIN();

void Inicia_Allegro()
{
	allegro_init();

	set_color_depth(32);
	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 1024, 768, 0, 0);

	install_keyboard();

	Retangulos = create_bitmap(1024, 768);
}

void Move_Retangulo()
{
	if(key[KEY_RIGHT])
	{
		Quadrado[0].X[0] += 5;
		
		if(Quadrado[0].X[0] >= 924) Quadrado[0].X[0] -= 5;
	}

	if(key[KEY_LEFT])
	{
		Quadrado[0].X[0] -= 5;
		
		if(Quadrado[0].X[0] <= 0) Quadrado[0].X[0] += 5;
	}
	
	if(key[KEY_UP])
	{
		Quadrado[0].Y[0] += 5;
		
		if(Quadrado[0].Y[0] >= 768) Quadrado[0].Y[0] -= 5;
	}

	if(key[KEY_DOWN])
	{
		Quadrado[0].Y[0] -= 5;
		
		if(Quadrado[0].Y[0] <= 100) Quadrado[0].Y[0] += 5;
	}

	Inicia_Dados(Quadrado[0].X[0], Quadrado[0].Y[0], Quadrado[1].X[0], Quadrado[1].Y[0]);
}

void Desenha_Retangulo()
{
	clear(Retangulos);

	rectfill(Retangulos, Quadrado[1].X[0] - 2, 768 - (Quadrado[1].Y[0] + 2), Quadrado[1].X[2] + 2, 768 - (Quadrado[1].Y[2] - 2), makecol(255, 0, 0));

	rectfill(Retangulos, Quadrado[0].X[0] - 2, 768 - (Quadrado[0].Y[0] + 2), Quadrado[0].X[2] + 2, 768 - (Quadrado[0].Y[2] - 2), makecol(0, 255, 0));

	blit(Retangulos, screen, 0, 0, 0, 0, 1024, 768);
}

void Inicia_Programa()
{
	int X, Y;
	
	Inicia_Allegro();
	Inicia_Dados(800, 600, 460, 435);

	X = Quadrado[0].X[0];
	Y = Quadrado[0].Y[0];

	Desenha_Retangulo();

	while(!key[KEY_ESC])
	{
		Move_Retangulo();

		Teste_Colisao(X, Y);

		if((X != Quadrado[0].X[0]) || (Y != Quadrado[0].Y[0]))
		{
			Desenha_Retangulo();

			X = Quadrado[0].X[0];
			Y = Quadrado[0].Y[0];

			rest(5);
		}
	};
}

void Teste_Colisao(int Xa, int Ya)
{
	int i, j;
	double D, Erro;

	Erro = 999999;
	D = -1;

	for(i = 0; i < 4; i ++) //Coordenadas Quadrado Verde
	{
		for(j = 0; j < 4; j ++) //Coordenadas Quadrado Vermelho
		{
			D = sqrt(pow(((double)(Quadrado[0].X[i] - Quadrado[1].X[j])), 2) + pow(((double)(Quadrado[0].Y[i] - Quadrado[1].Y[j])), 2));

			if(i != 3) D += sqrt(pow(((double)(Quadrado[0].X[i+1] - Quadrado[1].X[j])), 2) + pow(((double)(Quadrado[0].Y[i+1] - Quadrado[1].Y[j])), 2));
			else D += sqrt(pow(((double)(Quadrado[0].X[0] - Quadrado[1].X[j])), 2) + pow(((double)(Quadrado[0].Y[0] - Quadrado[1].Y[j])), 2));

			if(Erro > fabs(D - 100)) Erro = fabs(D - 100);
		}
	}
	
	if(Erro < 0.01)
	{
		if((Quadrado[0].X[0] - Xa) < 0) Quadrado[0].X[0] += 5;
		if((Quadrado[0].X[0] - Xa) > 0) Quadrado[0].X[0] -= 5;

		if((Quadrado[0].Y[0] - Ya) < 0) Quadrado[0].Y[0] += 5;
		if((Quadrado[0].Y[0] - Ya) > 0) Quadrado[0].Y[0] -= 5;
	}
}

void Inicia_Dados(int Xa, int Ya, int Xb, int Yb)
{
	Quadrado[0].X[0] = Xa;
	Quadrado[0].X[1] = Xa + 100;
	Quadrado[0].X[2] = Xa + 100;
	Quadrado[0].X[3] = Xa;

	Quadrado[0].Y[0] = Ya;
	Quadrado[0].Y[1] = Ya;
	Quadrado[0].Y[2] = Ya - 100;
	Quadrado[0].Y[3] = Ya - 100;

	Quadrado[1].X[0] = Xb;
	Quadrado[1].X[1] = Xb + 100;
	Quadrado[1].X[2] = Xb + 100;
	Quadrado[1].X[3] = Xb;

	Quadrado[1].Y[0] = Yb;
	Quadrado[1].Y[1] = Yb;
	Quadrado[1].Y[2] = Yb - 100;
	Quadrado[1].Y[3] = Yb - 100;
}
