#include <allegro.h>
#include <math.h>

void Inicia_Allegro();

void Carrega_Imagens();
void Desenha_Bitmaps();

void Inicia_Jogadores();
void Inicia_Jogo();

void Move_Humanos();

void Rotacao();

void Analise_Colisao();
void Colisao_Mapa();
void Colisao_Jogador(int Num_Jogador);

void Sair();

void Placar();

float Calculo_Det(float Xa, float Ya, float Xb, float Yb, float Xc, float Yc);

BITMAP *Fundo, *Carro_1, *Carro_2, *Carro_3, *Carro_4, *Restore;
PALETTE pal;
FONT *Texto;

struct Jogadores
{
	float Pos[2];
	float Xc;
	float Yc;

	float Colisao_X[4];
	float Colisao_Y[4];

	int Ang;
	
	float Vel;

	int Pontos;
	int Vida;

	int Id;
}Jogador[2];

int main(void)
{
	Inicia_Allegro();

	Inicia_Jogo();
	
	return 0;
}
END_OF_MAIN();

void Inicia_Allegro()
{
	allegro_init();

	set_color_depth(32);
	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 1024, 768, 0, 0);

	install_keyboard();

	Carrega_Imagens();
}

void Carrega_Imagens()
{
	Fundo = load_bitmap("Imagens\\Mapas\\Mapa_1.bmp", pal);
	Restore = load_bitmap("Imagens\\Mapas\\Restore.bmp", pal);

	Carro_1 = load_bitmap("Imagens\\Carros\\Carro_1.bmp", pal);
	Carro_2 = load_bitmap("Imagens\\Carros\\Carro_2.bmp", pal);
	
	Texto = load_font("Imagens\\Fontes\\Fonte.pcx", pal, NULL);
}

void Desenha_Bitmaps()
{
	draw_sprite(screen, Fundo, 163, 145);

	rotate_sprite(screen, Carro_1, Jogador[0].Pos[0], (768 - Jogador[0].Pos[1]), itofix(Jogador[0].Ang));
	rotate_sprite(screen, Carro_2, Jogador[1].Pos[0], (768 - Jogador[1].Pos[1]), itofix(Jogador[1].Ang));
	
	Placar();

	rest(15);
}

void Inicia_Jogadores()
{
	Jogador[0].Pos[0] = 190;
	Jogador[0].Pos[1] = 560;
	Jogador[0].Xc = Jogador[0].Pos[0] + 48;
	Jogador[0].Yc = Jogador[0].Pos[1] - 15;
	Jogador[0].Ang = 32;
	Jogador[0].Vel = 0;
	Jogador[0].Pontos = 0;
	Jogador[0].Vida = 100;
	Jogador[0].Id = 0;

	Jogador[1].Pos[0] = 740;
	Jogador[1].Pos[1] = 195;
	Jogador[1].Xc = Jogador[1].Pos[0] + 48;
	Jogador[1].Yc = Jogador[1].Pos[1] - 15;
	Jogador[1].Ang = -96;
	Jogador[1].Vel = 0;
	Jogador[1].Pontos = 0;
	Jogador[1].Vida = 100;
	Jogador[1].Id = 1;
}

void Inicia_Jogo()
{
	Inicia_Jogadores();

	Desenha_Bitmaps();

	while(!key[KEY_ESC])
	{
		Move_Humanos();
		
		Rotacao();
		Analise_Colisao();

		Desenha_Bitmaps();
	};

	Sair();
}

void Move_Humanos()
{
	float T = 1;
	float Pi = 3.14159265;

	bool Op_1 = false;
	bool Op_2 = false;

	if(fabs(Jogador[0].Vel) < 0.1) Jogador[0].Vel = 0;
	if(fabs(Jogador[1].Vel) < 0.1) Jogador[1].Vel = 0;
	
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Comandos do Jogador 1
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	if((key[KEY_UP] || key[KEY_DOWN] || (Jogador[0].Vel != 0)) && (Jogador[0].Vida > 0))
	{
		if(key[KEY_LEFT]) Jogador[0].Ang --;

		if(key[KEY_RIGHT]) Jogador[0].Ang ++;

		if(key[KEY_UP])
		{
			Jogador[0].Vel += 0.3;

			if(Jogador[0].Vel > 5) Jogador[0].Vel = 5;

			Op_1 = true;
		}

		if(key[KEY_DOWN])
		{
			Jogador[0].Vel -= 0.2;

			if(Jogador[0].Vel < -3.5) Jogador[0].Vel = -3.5;

			Op_1 = true;
		}
	}

	if(!Op_1)
	{
		if(Jogador[0].Vel > 0) Jogador[0].Vel -= 0.1;
		if(Jogador[0].Vel < 0) Jogador[0].Vel += 0.1;
	}
	
	if(Jogador[0].Ang <= 0) Jogador[0].Ang += 256;
	if(Jogador[0].Ang >= 256) Jogador[0].Ang -= 256;
	
	Jogador[0].Pos[0] += Jogador[0].Vel*cos((float)(360 - Jogador[0].Ang*45/32)*Pi/180)*T;
	Jogador[0].Pos[1] += Jogador[0].Vel*sin((float)(360 - Jogador[0].Ang*45/32)*Pi/180)*T;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Comandos do Jogador 2
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	if((key[KEY_W] || key[KEY_S] || (Jogador[1].Vel != 0)) && (Jogador[1].Vida > 0))
	{
		if(key[KEY_A]) Jogador[1].Ang --;

		if(key[KEY_D]) Jogador[1].Ang ++;

		if(key[KEY_W])
		{
			Jogador[1].Vel += 0.3;

			if(Jogador[1].Vel > 5) Jogador[1].Vel = 5;

			Op_2 = true;
		}

		if(key[KEY_S])
		{
			Jogador[1].Vel -= 0.2;

			if(Jogador[1].Vel < -3.5) Jogador[1].Vel = -3.5;

			Op_2 = true;
		}
	}

	if(!Op_2)
	{
		if(Jogador[1].Vel > 0) Jogador[1].Vel -= 0.1;
		if(Jogador[1].Vel < 0) Jogador[1].Vel += 0.1;
	}
	
	if(Jogador[1].Ang <= 0) Jogador[1].Ang += 256;
	if(Jogador[1].Ang >= 256) Jogador[1].Ang -= 256;
	
	Jogador[1].Pos[0] += Jogador[1].Vel*cos((float)(360 - Jogador[1].Ang*45/32)*Pi/180)*T;
	Jogador[1].Pos[1] += Jogador[1].Vel*sin((float)(360 - Jogador[1].Ang*45/32)*Pi/180)*T;
}

void Rotacao()
{
	float Temp_X;

	float Pi = 3.14159265;

	int i, j;

	for(i = 0; i < 2; i++)
	{
		Jogador[i].Xc = Jogador[i].Pos[0] + 48;
		Jogador[i].Yc = Jogador[i].Pos[1] - 15;

		Jogador[i].Colisao_X[0] = Jogador[i].Pos[0];
		Jogador[i].Colisao_Y[0] = Jogador[i].Pos[1];

		Jogador[i].Colisao_X[1] = Jogador[i].Pos[0] + 95;
		Jogador[i].Colisao_Y[1] = Jogador[i].Pos[1];

		Jogador[i].Colisao_X[2] = Jogador[i].Pos[0] + 95;
		Jogador[i].Colisao_Y[2] = Jogador[i].Pos[1] - 29;

		Jogador[i].Colisao_X[3] = Jogador[i].Pos[0];
		Jogador[i].Colisao_Y[3] = Jogador[i].Pos[1] - 29;
		
		for(j = 0; j < 4; j++)
		{
			Temp_X = Jogador[i].Colisao_X[j];

			Jogador[i].Colisao_X[j] = Jogador[i].Xc + ((Temp_X - Jogador[i].Xc)*cos((float)(360 - Jogador[i].Ang*45/32)*Pi/180) - (Jogador[i].Colisao_Y[j] - Jogador[i].Yc)*sin((float)(360 - Jogador[i].Ang*45/32)*Pi/180));
			Jogador[i].Colisao_Y[j] = Jogador[i].Yc + ((Temp_X - Jogador[i].Xc)*sin((float)(360 - Jogador[i].Ang*45/32)*Pi/180) + (Jogador[i].Colisao_Y[j] - Jogador[i].Yc)*cos((float)(360 - Jogador[i].Ang*45/32)*Pi/180));
		}
	}
}

void Analise_Colisao()
{
	int i;
	
	Colisao_Mapa();

	for(i = 0; i < 2; i ++)
	{
		Colisao_Jogador(i);
	}
}

void Colisao_Mapa()
{
	int i, j;
	bool Colisao;
	
	for(i = 0; i < 2; i ++)
	{
		Colisao = false;

		for(j = 0; j < 4; j ++)
		{
			if(((int)(Jogador[i].Colisao_X[j]) <= 190) || ((int)(Jogador[i].Colisao_X[j]) >= 834))
			{
				Colisao = true;
			}

			if(((int)(Jogador[i].Colisao_Y[j]) <= 133) || ((int)(Jogador[i].Colisao_Y[j]) >= 594))
			{
				Colisao = true;
			}
		}

		if((Colisao) && (Jogador[i].Vel != 0))
		{
			Jogador[i].Vel = (-1)*(Jogador[i].Vel);
			if(Jogador[i].Vida > 0) Jogador[i].Vida --;

			else Jogador[i].Vel = 0;
		}
	}
}

void Colisao_Jogador(int Num_Jogador)
{
	int i, j, k, Temp_Jog;
	float D[3], Erro, Temp_Vel;
	
	Erro = 999999;
	Temp_Jog = -1;
	
	for(i = 0; i < 2; i ++) //Jogador Alvo
	{
		if(i != Jogador[Num_Jogador].Id) //Jogador Analisado != Jogador Alvo
		{
			for(j = 0; j < 4; j ++) //Coordenadas Jogador Analisado
			{
				for(k = 0; k < 4; k ++) //Coordenadas Jogador Alvo
				{
					if(k != 3)
					{
						D[0] = sqrt(pow((Jogador[i].Colisao_X[k] - Jogador[i].Colisao_X[k+1]), 2) + pow((Jogador[i].Colisao_Y[k] - Jogador[i].Colisao_Y[k+1]), 2));
						D[1] = sqrt(pow((Jogador[Num_Jogador].Colisao_X[j] - Jogador[i].Colisao_X[k]), 2) + pow((Jogador[Num_Jogador].Colisao_Y[j] - Jogador[i].Colisao_Y[k]), 2));
						D[2] = sqrt(pow((Jogador[Num_Jogador].Colisao_X[j] - Jogador[i].Colisao_X[k+1]), 2) + pow((Jogador[Num_Jogador].Colisao_Y[j] - Jogador[i].Colisao_Y[k+1]), 2));
					}

					else
					{
						D[0] = sqrt(pow((Jogador[i].Colisao_X[0] - Jogador[i].Colisao_X[3]), 2) + pow((Jogador[i].Colisao_Y[0] - Jogador[i].Colisao_Y[3]), 2));
						D[1] = sqrt(pow((Jogador[Num_Jogador].Colisao_X[j] - Jogador[i].Colisao_X[0]), 2) + pow((Jogador[Num_Jogador].Colisao_Y[j] - Jogador[i].Colisao_Y[0]), 2));
						D[2] = sqrt(pow((Jogador[Num_Jogador].Colisao_X[j] - Jogador[i].Colisao_X[3]), 2) + pow((Jogador[Num_Jogador].Colisao_Y[j] - Jogador[i].Colisao_Y[3]), 2));
					}

					if(Erro > fabs(D[1] + D[2] - D[0]))
					{
						Erro = fabs(D[1] + D[2] - D[0]);

						if((int)Erro == 0)
						{
							Temp_Jog = i;

							break;
						}
					}
				}

				if((int)Erro == 0) break;
			}
		}

		if((int)Erro == 0) break;
	}

	if((int)Erro == 0)
	{
		if(Temp_Jog != -1)
		{
			if((Jogador[Num_Jogador].Vida > 0) && (Jogador[Temp_Jog].Vida > 0))
			{
				if((fabs(Jogador[Num_Jogador].Vel) >= 1) || (fabs(Jogador[Temp_Jog].Vel) >= 1))
				{
					Jogador[Num_Jogador].Pontos ++;
					Jogador[Temp_Jog].Vida --;
				}
			}

			Temp_Vel = (fabs(Jogador[Num_Jogador].Vel) + fabs(Jogador[Temp_Jog].Vel));

			if(Jogador[Num_Jogador].Vel > 0)
			{
				if((fabs((float)(Jogador[Num_Jogador].Ang - Jogador[Temp_Jog].Ang)) < 64) || (fabs((float)(Jogador[Num_Jogador].Ang - Jogador[Temp_Jog].Ang)) > 192))
				{
					Jogador[Num_Jogador].Vel = -(Temp_Vel/2);
					Jogador[Temp_Jog].Vel = (Temp_Vel/2);
				}
				
				if((fabs((float)(Jogador[Num_Jogador].Ang - Jogador[Temp_Jog].Ang)) > 64) && (fabs((float)(Jogador[Num_Jogador].Ang - Jogador[Temp_Jog].Ang)) < 192))
				{
					Jogador[Num_Jogador].Vel = (Temp_Vel/2);
					Jogador[Temp_Jog].Vel = -(Temp_Vel/2);
				}
			}

			else
			{
				Jogador[Num_Jogador].Vel = (Temp_Vel/2);
				Jogador[Temp_Jog].Vel = -(Temp_Vel/2);
			}
		}
	}
}

float Calculo_Det(float Xa, float Ya, float Xb, float Yb, float Xc, float Yc)
{
	float A;

	A = (((unsigned)(Xa*Yb + Xb*Yc + Xc*Ya - Xc*Yb - Xb*Ya - Xa*Yc))/2);

	return A;
}

void Sair()
{
	destroy_bitmap(Fundo);
	destroy_bitmap(Carro_1);
	destroy_bitmap(Carro_2);
	
	destroy_font(Texto);

	allegro_exit();

	exit(0);
}

void Placar()
{
	char Info[17];

	draw_sprite(screen, Restore, 0, 715);

	usprintf(Info, "Pontos : %d   ", Jogador[0].Pontos);
	textout_ex(screen, Texto, Info, 0, 710, makecol(10, 10, 255), -1);

	usprintf(Info, "Energia : %d   ", Jogador[0].Vida);
	textout_ex(screen, Texto, Info, 263, 710, makecol(10, 10, 255), -1);

	usprintf(Info, "Pontos : %d   ", Jogador[1].Pontos);
	textout_ex(screen, Texto, Info, 550, 710, makecol(255, 10, 10), -1);

	usprintf(Info, "Energia : %d   ", Jogador[1].Vida);
	textout_ex(screen, Texto, Info, 813, 710, makecol(255, 10, 10), -1);
}
