#include <allegro.h>

void Inicia_Allegro();
void Inicia_Programa();

bool Move_Desenho();
void Desenha();
void Sair();

//Ponteiro para um bitmap.
BITMAP *Desenho, *Fundo;

//Palheta de cores padro (RGB).
PALETTE pal;

int X = 512;
int Y = 384;
int A = 0;

int main(void)
{
	Inicia_Allegro();

	Inicia_Programa();

	return 0;
}
END_OF_MAIN();
//No final da funo int main(void) SEMPRE devemos colocar END_OF_MAIN();,  explicitar o final dela.

void Inicia_Allegro()
{
	//A ordem DEVE ser sempre respeitada at set_gfx_mode();, aps fica livre a ordem de comandos (depende da complexidade dos eventos).
	
	//Inicia de fato o Allegro.
	allegro_init();

	//Define a quantidade de cores utilizadas, nesse caso True Color (32 bits).
	set_color_depth(32); 
	
	//Define a janela e o modo de acelerao, nesse caso o compilador verifica qual  a melhor opo do acelerador, e define uma tela de 1024x768 pixels.
	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 1024, 768, 0, 0); 

	//Reconhece o teclado.
	install_keyboard();

	//Ponteiro para arquivo local (na mesma pasta onde o executvel se encontra).
	Desenho = load_bitmap("Desenho.bmp", pal);
	
	//O fundo ser um retngulo de 1024x768 pixels.
	Fundo = create_bitmap(1024, 768);

	//Para apontar para um lugar especfico:
	//Desenho = load_bitmap("C:\\ALGUMA_PASTA\\Desenho.bmp", pal);

	//Uma ateno especial para o local apontado, pois ao se executar o programa no for
	//possvel encontrar o arquivo, acontecer um bug e o aplicativo NO ser fechado
	//corretamente.

	//Existe o conceito de transparncia de um bitmap, pesquisar como se d esta condio.

	//Pode-se usar de uma outra forma, trabalha diretamente com os pixels.
	//Desenho = create_bitmap(1024, 768);

	//O create_bitmap(); deve conter o valor explicitado em set_gfx_mode();.
	//Depois de criado como pixel, deve-se limpar sua memoria (tal comando pode ser usado em qualquer tipo de BITMAP).

	//clear(Desenho);

	//Pontos importantes:

	//Esse comando pode ser usado tanto para limpar a memria alocada para um determinado fim de um BITMAP, como tambm
	//limpar a tela.

	//Em seguida podemos definir o que esse Desenho ser, o Allegro suporta alguns comandos para trabalhar com pixel:

	//linhas (horizontais, verticais, inclinadas);
	//retngulos (linhas ou hachurado);
	//tringulos (apenas hachurado);
	//circunsferncias (linha ou hachurado);
	//e outros recursos mais complexos (a quem interessar pesquise em www.allegro.cc/manual).
}

void Inicia_Programa()
{
	//Se no acontecer a seguinte flag (evento), continuar a executar o loop,  a base de todo o programa
	//do Allegro, um aplicativo com loop infinito que s sair se o usurio apertar ESC.

	//Comandos do tipo key[KEY_ESC] so flags, caso o usurio aperte a devida tecla, ir desencadear uma
	//srie de outros comandos.

	bool Movimento = false;

	Desenha();
	
	while(!key[KEY_ESC])
	{
		Movimento = Move_Desenho();

		//S ser desenhado novamente se o usurio movimentar o desenho (evita comandos desnecessrios).
		if(Movimento) Desenha();

		Movimento = false;
	};

	Sair();
}

bool Move_Desenho()
{
	bool Movimento = false;
	
	//Seta direcional para cima
	if(key[KEY_DOWN])
	{
		//A tela  invertida em relao ao eixo Y no sistema de coordenadas cartesianas.
		//A parte superior esquerda  a origem do sistema, e a parte inferior direita possue as coordenadas (1024, 768), lembro novamente
		//que depende da resoluo definida pelo programador.
		
		//Fator de deslocamento, ou velocidade.
		Y -= 5;

		//Evita que o desenho "saia" da tela.
		if(Y < 335) Y += 5;

		Movimento = true;
	}

	if(key[KEY_UP])
	{
		Y += 5;

		if(Y > 768) Y -= 5;

		Movimento = true;
	}

	if(key[KEY_LEFT])
	{
		X -= 5;

		if(X < 0) X += 5;

		Movimento = true;
	}

	if(key[KEY_RIGHT])
	{
		X += 5;

		if(X > 735) X -= 5;

		Movimento = true;
	}

	if(key[KEY_A])
	{
		//A seguinte varivel tratar da rotao do bitmap (aplicvel apenas para bitmaps que apontem para arquivos).
		//Para um incremento posivito de A, a rotao ser no sentido horrio.

		A -= 2;

		Movimento = true;
	}

	if(key[KEY_Z])
	{
		A += 2;

		Movimento = true;
	}

	return Movimento;
}

void Desenha()
{
	//"Joga" na tela o bitmap.
	//Do ponto de vista funcional, o correto seria limpar a tela antes de desenhar,
	//mas ao proceder desta maneira, normalmente fica evidente a tela piscar em
	//mquinas que no possuem placa de vdeo e/ou um processador relativamente bom.

	//O mais indicado  "enganar" o usurio, fazer com que ele tenha a falsa sensao
	//de que nada aconteceu  o mais indicado.

	//Esse comando  suficiente em 90% dos casos, contudo caso queira que a figura
	//tenha rotao, esse j no serve.
	//draw_sprite(screen, Fundo, 0, 0);
	
	//Comando para definir uma imagem que ser um retngulo preenchido, o primeiro
	//parmetro  onde o retngulo ser armazenado, o segundo e o terceiro parmetros
	//so as coordenadas X e Y do canto superior esquerdo, o quarto e quinto do canto
	//inferior direito e finalmente o sexto  a cor do retngulo no formato (R,G,B).
	rectfill(Fundo, 0, 0, 1024, 768, makecol(84, 109, 142));
	
	//Funo para colocar na tela a imagem que previamente estava alocada na memria.
	//O primeiro parmetro  a fonte de origem, o segundo o destino (no caso a tela),
	//o terceiro e quarto, sao as coordenadas do canto superior esquerdo da fonte de
	//origem, o quinto e sexto, sao as coordenadas do canto superior esquerdo do
	//destino e o stimo e oitavo parmetros retratam qual  a resoluo da imagem.
	blit(Fundo, screen, 0, 0, 0, 0, 1024, 768);

	//Como esse programa a figura possue uma rotao, ser usado o seguinte comando:
	rotate_sprite(screen, Desenho, X, (768 - Y), itofix(A));

	//O uso do (768 - Y) na hora de colocar o desenho na tela, serve para deixar o
	//sistema de coordenadas trabalhado como sendo o cartesiano.

	//Alguns pontos importantes:
	//O bitmap  sempre tratado como um retngulo, e as coordenadas (X, Y) nesse caso
	//so referentes a sua poro superior esquerda, assim como na tela. O ngulo de
	//rotao NO  em graus. Sempre que se for necessria uma converso desse valor, 
	//o seguinte clculo deve ser feito:

	//Angulo em graus = Angulo do Allegro * (45/32).

	//Pois internamente  trabalhado com a relao:

	//45 = 32;

	//O centro de rotao  no centro do retngulo que contm o bitmap e no a imagem
	//desenhada.

	rest(15);

	//Normalmente o tempo do loop  da ordem de alguns milisegundos (milsimos de segundo)
	//o que pode fazer com que a tela pisque. Atrasar o loop  uma alternativa para
	//minimizar esse efeito.
}

void Sair()
{
	//Quando no  mais necessrio um bitmap, deve-se sempre liberar a memria alocada.
	destroy_bitmap(Desenho);
	destroy_bitmap(Fundo);

	//O mesmo vale para os perifricos reconhecidos.
	remove_keyboard();

	//O Allegro possue uma funo que normalmente efetua automaticamente todos esses
	//procedimentos, mas no  recomendado apenas usar ela individualmente, pois existem
	//atributos que no so liberados.
	allegro_exit();

	exit(0);
}
